# 167. Two Sum II - Input array is sorted

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/two-sum-ii-input-array-is-sorted/description/

> 内容描述

```
Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

Note:

Your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution and you may not use the same element twice.
Example:

Input: numbers = [2,7,11,15], target = 9
Output: [1,2]
Explanation: The sum of 2 and 7 is 9. Therefore index1 = 1, index2 = 2.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

算法来源于知乎文章——[趣味算法思想](https://zhuanlan.zhihu.com/p/46223775)
* 由于数组是有序的，所以可以从两边向中间逐渐收敛地进行查找，好处在于避免了双重循环
* 如果最两端的和小于目标数，则可以让左侧下标+1，然后重新进行运算比较
* 如果最两端的和大于目标数，则可以让右侧下标-1，然后重新进行运算比较

代码：

```javascript
/**
 * @param {number[]} numbers
 * @param {number} target
 * @return {number[]}
 */
var twoSum = function(nums, target) {
    var number=[];
    var left = 0;
    var right = nums.length - 1 ;
    while(left < right ) {
        if(nums[left] + nums[right] === target) {
            return [left+1, right+1]
        } else if(nums[left] + nums[right] > target ) {
            right--;
        } else {
            left++;
        }
    } 
};
```

